# 0 "gnetbyad.c"
# 0 "<built-in>"
# 0 "<command-line>"
# 1 "gnetbyad.c"
/*
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

# 1 "../../../../../include/sys/socket.h" 1
/*
 *  libsocket - BSD socket like library for DJGPP
 *  Copyright 1997, 1998 by Indrek Mandre
 *  Copyright 1997-2000 by Richard Dawe
 *
 *  Portions of libsocket Copyright 1985-1993 Regents of the University of
 *  California.
 *  Portions of libsocket Copyright 1991, 1992 Free Software Foundation, Inc.
 *  Portions of libsocket Copyright 1997, 1998 by the Regdos Group.
 *
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Library General Public License as published
 *  by the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */







# 1 "../../../../../include/sys/types.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1997 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 25 "../../../../../include/sys/types.h"
# 1 "../../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 23 "../../../../../include/sys/djtypes.h"
/* For GCC 3.00 or later we use its builtin va_list.                       */
# 34 "../../../../../include/sys/djtypes.h"
/* but remains a typedef in C */





/* Define internal type to be used for avoiding strict
   aliasing warnings */

typedef short __attribute__((__may_alias__)) __dj_short_a;
typedef int __attribute__((__may_alias__)) __dj_int_a;
typedef long __attribute__((__may_alias__)) __dj_long_a;
typedef long long __attribute__((__may_alias__)) __dj_long_long_a;
typedef unsigned short __attribute__((__may_alias__)) __dj_unsigned_short_a;
typedef unsigned int __attribute__((__may_alias__)) __dj_unsigned_int_a;
typedef unsigned long __attribute__((__may_alias__)) __dj_unsigned_long_a;
typedef unsigned long long __attribute__((__may_alias__)) __dj_unsigned_long_long_a;
typedef float __attribute__((__may_alias__)) __dj_float_a;
typedef double __attribute__((__may_alias__)) __dj_double_a;
typedef long double __attribute__((__may_alias__)) __dj_long_double_a;
# 26 "../../../../../include/sys/types.h" 2

typedef int blkcnt_t;
typedef int blksize_t;
typedef int dev_t;
typedef unsigned long fsblkcnt_t;
typedef unsigned long fsfilcnt_t;
typedef int ino_t;
typedef int mode_t;
typedef int nlink_t;


typedef int gid_t;



typedef int off_t;



__extension__ typedef long long off64_t;



__extension__ typedef long long offset_t;



typedef int pid_t;



typedef long unsigned int size_t;



typedef long signed int ssize_t;




typedef int uid_t;




/* Allow including program to override.  */




typedef struct fd_set {
  unsigned char fd_bits [((256) + 7) / 8];
} fd_set;







typedef unsigned int time_t;
# 33 "../../../../../include/sys/socket.h" 2
# 1 "../../../../../include/sys/ioctl.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1996 DJ Delorie, see COPYING.DJ for details */
# 23 "../../../../../include/sys/ioctl.h"
/*
**  plain ioctl functions. Do not use them.
**  Never. Really _N_E_V_E_R_. Unless you really know what
**  you are doing.
**
*/
# 47 "../../../../../include/sys/ioctl.h"
/*
**  Flags for DOS commands
*/


                                       /* what to return. 8 possible values */

                                       /* bytes to transfer                 */





/*
** DOS ioctls we support:
*/
# 75 "../../../../../include/sys/ioctl.h"
/*
These ones do not fit into my scheme, because they _DO_NOT_ put the size
of the xfer buffer in CX. Aaaaargh
*/
# 89 "../../../../../include/sys/ioctl.h"
/* UNIX stuff - Most of it disabled.  */

/*
** __WARNING__ :
** This ifdef works for DJGPP, because its io.h
** defines __djgpp_include_io_h_
*/

/*
* Ioctl's have the command encoded in the lower word,
* and the size of any in or out parameters in the upper
* word.  The high 2 bits of the upper word are used
* to encode the in/out status of the parameter; for now
* we restrict parameters to at most 128 bytes.
*/





/* the 0x20000000 is so we can distinguish new ioctl's from old */



/* this should be _IORW, but stdio got there first */



/*
 * window size structure used with TXSETWIN and TXGETWIN.  This is
 * exactly the same as the Berkeley structure and can be used with
 * TIOCSWINSZ and TIOCGWINSZ -- in fact they are defined to be the
 * same.
 */
struct winsize {
 unsigned short ws_row; /* rows, in characters */
 unsigned short ws_col; /* columns, in characters */
 unsigned short ws_xpixel; /* horizontal size, pixels */
 unsigned short ws_ypixel; /* vertical size, pixels */
};
# 351 "../../../../../include/sys/ioctl.h"
int ioctl( int fd, int cmd, ...);
# 34 "../../../../../include/sys/socket.h" 2
# 1 "../../../../../include/lsck/bsdtypes.h" 1
/*
 *  libsocket - BSD socket like library for DJGPP
 *  Copyright 1997, 1998 by Indrek Mandre
 *  Copyright 1997-2000 by Richard Dawe
 *
 *  Portions of libsocket Copyright 1985-1993 Regents of the University of
 *  California.
 *  Portions of libsocket Copyright 1991, 1992 Free Software Foundation, Inc.
 *  Portions of libsocket Copyright 1997, 1998 by the Regdos Group.
 *
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Library General Public License as published
 *  by the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
    bsdtypes.h - BSD types used by some of libsocket's code.
*/
# 37 "../../../../../include/lsck/bsdtypes.h"
typedef unsigned int u_int32_t;
typedef unsigned short u_int16_t;

typedef unsigned int u_long;
typedef unsigned int u_int;
typedef unsigned short u_short;
typedef unsigned char u_char;

typedef char * __caddr_t;
typedef __caddr_t caddr_t;
# 35 "../../../../../include/sys/socket.h" 2
# 1 "../../../../../include/lsck/errno.h" 1
/*
 *  libsocket - BSD socket like library for DJGPP
 *  Copyright 1997, 1998 by Indrek Mandre
 *  Copyright 1997-2000 by Richard Dawe
 *
 *  Portions of libsocket Copyright 1985-1993 Regents of the University of
 *  California.
 *  Portions of libsocket Copyright 1991, 1992 Free Software Foundation, Inc.
 *  Portions of libsocket Copyright 1997, 1998 by the Regdos Group.
 *
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Library General Public License as published
 *  by the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */




# 1 "../../../../../include/errno.h" 1
/* Copyright (C) 2015 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */







# 1 "../../../../../include/libc/asmobj.h" 1
/*
 *  dj64 - 64bit djgpp-compatible tool-chain
 *  Copyright (C) 2021-2024  @stsp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

# 1 "../../../../../include/libc/djthunks.h" 1
/*
 *  dj64 - 64bit djgpp-compatible tool-chain
 *  Copyright (C) 2021-2024  @stsp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */




# 1 "../../../../../include/stdint.h" 1
/* Copyright (C) 2015 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2014 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2013 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
# 17 "../../../../../include/stdint.h"
typedef signed char int_least8_t;
typedef unsigned char uint_least8_t;
typedef signed char int_fast8_t;
typedef unsigned char uint_fast8_t;
typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef signed short int int_least16_t;
typedef unsigned short int uint_least16_t;
typedef signed int int_fast16_t;
typedef unsigned int uint_fast16_t;
typedef signed short int int16_t;
typedef unsigned short int uint16_t;

typedef signed int int_least32_t;
typedef unsigned int uint_least32_t;
typedef signed int int_fast32_t;
typedef unsigned int uint_fast32_t;
typedef signed int int32_t;
typedef unsigned int uint32_t;

__extension__ typedef signed long long int int_least64_t;
__extension__ typedef unsigned long long int uint_least64_t;
__extension__ typedef signed long long int int_fast64_t;
__extension__ typedef unsigned long long int uint_fast64_t;
__extension__ typedef signed long long int int64_t;
__extension__ typedef unsigned long long int uint64_t;

typedef long int intptr_t;
typedef unsigned long int uintptr_t;

__extension__ typedef signed long int intmax_t;
__extension__ typedef unsigned long int uintmax_t;




/* ANSI/ISO C99 says these should not be visible in C++ unless
   explicitly requested.  */

//#if !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS)
# 113 "../../../../../include/stdint.h"
  /* These are defined by limits.h, so make them conditional.  */
# 127 "../../../../../include/stdint.h"
//#endif /* !__cplusplus || __STDC_LIMIT_MACROS */
# 23 "../../../../../include/libc/djthunks.h" 2

void crt1_startup(int handle);

uint8_t *djaddr2ptr(uint32_t addr);
uint8_t *djaddr2ptr2(uint32_t addr, uint32_t len);
uint32_t djptr2addr(const uint8_t *ptr);
uint32_t djthunk_get(const char *name);
uint32_t djthunk_get_h(int handle, const char *name);
void *djsbrk(int increment);
int djelf_load(int num, int libid);
int djelf_exec(void);
# 20 "../../../../../include/libc/asmobj.h" 2
# 16 "../../../../../include/errno.h" 2







extern int *____dj_errno(void);/*
*/
# 23 "../../../../../include/errno.h"
       #define __dj_errno (*____dj_errno())/*
*/
# 23 "../../../../../include/errno.h"
                             ;
# 77 "../../../../../include/errno.h"
/* EILSEQ		41 */

extern char * sys_errlist[];
extern int sys_nerr;
extern const char * __sys_errlist[];
extern int __sys_nerr;
extern int _doserrno;
# 30 "../../../../../include/lsck/errno.h" 2






/* RD: DJGPP 2.04 will have symlink support, so ELOOP will be defined.
 * If it's not, then use DJGPP 2.04's constant. */
# 36 "../../../../../include/sys/socket.h" 2






/* --- Constants --- */







/* Flags we can use with send/ and recv. */




/* RD: Where did this come from? */






/*
 * Maximum queue length specifiable by listen.
 */





/* Setsockoptions(2) level. Thanks to BSD these must match IPPROTO_xxx */
# 79 "../../../../../include/sys/socket.h"
/* Link numbers.  */




/*
 * Address families.
 */
# 112 "../../../../../include/sys/socket.h"
/* RD: From Winsock 2 headers, we have: */

/*#define AF_MAX          22*/






/* End RD */

/*
 * Protocol families, same as address families for now.
 */
# 150 "../../../../../include/sys/socket.h"
/* RD: Winsock 2 new ones (see AF_* above) */




/* End RD */



/*
 * Option flags per-socket.
 */
# 174 "../../../../../include/sys/socket.h"
/*
 * Additional options.
 */
# 186 "../../../../../include/sys/socket.h"
/*
 * Options for connect and disconnect data and options.  Used only by
 * non-TCP/IP transports such as DECNet, OSI TP4, etc.
 */
# 199 "../../../../../include/sys/socket.h"
/*
 * Option for opening sockets for synchronous access.
 */





/*
 * Other NT-specific options.
 */





/*
 * TCP options.
 */
/*#define TCP_NODELAY     0x0001*/




/*
 * Define constant based on rfc883, used by gethostbyxxxx() calls.
 */


/* ioctl() and fcntl() defines. Currently #include <sys/ioctl.h> doesn't
   define the required constants because of an #ifdef. So, define them here.
   This may lead to problems later :( */
# 252 "../../../../../include/sys/socket.h"
/* Socket I/O Controls */






/*
 * Define flags to be used with the WSAAsyncSelect() call.
 */
/* RD: To use some of these requires Dan Hedlund's callback code IMHO. */







/* how parameter of shutdown */




/* --- Types --- */


typedef unsigned socklen_t;




typedef unsigned short sa_family_t;



/* - Structures - */

struct sockaddr
{
 sa_family_t sa_family; /* address family   */
 char sa_data[14]; /* protocol address */
};

struct linger {
        unsigned short l_onoff; /* Linger active   */
        unsigned short l_linger; /* Linger interval */
};

/* Support for readmsg(), sendmsg(). */
struct msghdr {
 void *msg_name; /* Optional address             */
 socklen_t msg_namelen; /* Size of address              */
 struct iovec *msg_iov; /* Scatter/gather array         */
 int msg_iovlen; /* # of members in msg_iov      */
 void *msg_control; /* Ancillary data               */
 socklen_t msg_controllen; /* Ancillary data buffer length */
 int flags; /* Flags on received message    */
};

/* Ancillary data type */
struct cmsghdr {
 socklen_t cmsg_len; /* Data byte count, including the cmsghdr */
 int cmsg_level; /* Originating protocol                   */
 int cmsg_type; /* Protocol-specific type                 */
};

/* TODO: Implement the following:

   . SCM_RIGHTS
   . CMSG_DATA
   . CMSG_NXTHDR
   . CMSG_FIRSTHDR
*/

/* --- Functions --- */

extern int socket (int, int, int);
extern int socketpair (int, int, int, int [2]);
extern int bind (int, struct sockaddr *, socklen_t);
extern int listen (int, int);
extern int connect (int, struct sockaddr *, socklen_t);
extern int accept (int, struct sockaddr *, socklen_t *);

extern ssize_t recv (int, void *, size_t, unsigned int);
extern ssize_t recvfrom (int, void *, size_t, unsigned int,
                         struct sockaddr *, socklen_t *);
extern ssize_t recvmsg (int, struct msghdr *, int);

extern ssize_t send (int, const void *, size_t, unsigned int);
extern ssize_t sendto (int, const void *, size_t, unsigned int,
         struct sockaddr *, socklen_t);
extern ssize_t sendmsg (int, const struct msghdr *, int);

extern int getsockname (int, struct sockaddr *, socklen_t *);
extern int getpeername (int, struct sockaddr *, socklen_t *);
extern int getsockopt (int, int, int, void *, socklen_t *);
extern int setsockopt (int, int, int, const void *, socklen_t);

extern int shutdown (int, int);

extern int rcmd (char **, unsigned short, const char *,
                 const char *, const char *, int *);
extern int rresvport (int *);
extern int ruserok (const char *, int, const char *, const char *);
extern int rexec (char **, int, const char *, const char *, const char *,
    int *);

extern int sockatmark (int);

/* Non-standard socket calls */
extern int closesocket (int);
extern int ioctlsocket (int, int, int *);
extern int fcntlsocket (int, int, int);
extern int selectsocket (int, int);

/* --- Out-of-place defines, functions, etc. --- */

/* - sys/stat.h - */
extern int isfdtype (int, int);
# 19 "gnetbyad.c" 2
# 1 "../../../../../include/netdb.h" 1
/*-
 * Copyright (c) 1980, 1983, 1988, 1993
 *     The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)netdb.h	8.1 (Berkeley) 6/2/93
 *      netdb.h,v 1.1.1.1 1995/02/18 05:34:07 hjl Exp
 * -
 * Portions Copyright (c) 1993 by Digital Equipment Corporation.
 *
 * Permission to use, copy, modify and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies, and that
 * the name of Digital Equipment Corporation not be used in advertising or
 * publicity pertaining to distribution of the document or software without
 * specific, written prior permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
 * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 * -
 * --Copyright--
 */

/*
   Richard Dawe (for libsocket): Temporarily commented out RPC functions as
   they are not currently implemented. Also added inet_nsap_*() functions,
   not that I know the function of them. Also made functions externs.
*/




# 1 "../../../../../include/lsck/errno.h" 1
/*
 *  libsocket - BSD socket like library for DJGPP
 *  Copyright 1997, 1998 by Indrek Mandre
 *  Copyright 1997-2000 by Richard Dawe
 *
 *  Portions of libsocket Copyright 1985-1993 Regents of the University of
 *  California.
 *  Portions of libsocket Copyright 1991, 1992 Free Software Foundation, Inc.
 *  Portions of libsocket Copyright 1997, 1998 by the Regdos Group.
 *
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Library General Public License as published
 *  by the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
# 67 "../../../../../include/netdb.h" 2
# 1 "../../../../../include/sys/socket.h" 1
/*
 *  libsocket - BSD socket like library for DJGPP
 *  Copyright 1997, 1998 by Indrek Mandre
 *  Copyright 1997-2000 by Richard Dawe
 *
 *  Portions of libsocket Copyright 1985-1993 Regents of the University of
 *  California.
 *  Portions of libsocket Copyright 1991, 1992 Free Software Foundation, Inc.
 *  Portions of libsocket Copyright 1997, 1998 by the Regdos Group.
 *
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Library General Public License as published
 *  by the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
# 68 "../../../../../include/netdb.h" 2





/* RD: Unix98 says we should define these. */
/* Fundamental Internet types */

typedef unsigned short in_port_t;




typedef unsigned in_addr_t;



/*
 * Structures returned by network data base library.  All addresses are
 * supplied in host order, and returned in network order (suitable for
 * use in system calls).
 */

  /* Different from the linux versions - note the shorts.. */
struct hostent {
 const char *h_name; /* official name of host */
 char **h_aliases; /* alias list */
 short h_addrtype; /* host address type */
 short h_length; /* length of address */
 char **h_addr_list; /* list of addresses from name server */

};

/*
 * Assumption here is that a network number
 * fits in an unsigned long -- probably a poor one.
 */

struct netent {
 char *n_name; /* official name of net */
 char **n_aliases; /* alias list */
 short n_addrtype; /* net address type */
 unsigned long n_net; /* network # */
};

struct servent {
 char *s_name; /* official service name */
 char **s_aliases; /* alias list */
 short s_port; /* port # */
 char *s_proto; /* protocol to use */
};

struct protoent
{
  char *p_name; /* official protocol name */
  char **p_aliases; /* alias list */
  short p_proto; /* protocol # */
};

struct addrinfo {
  int ai_flags;
  int ai_family;
  int ai_socktype;
  int ai_protocol;
  socklen_t ai_addrlen;
  struct sockaddr *ai_addr;
  char *ai_canonname;
  struct addrinfo *ai_next;
};

/*struct rpcent {
	char	*r_name;	*//* name of server for this rpc program */
/*	char	**r_aliases;	*//* alias list */
/*	int	r_number;	*//* rpc program number */
/*};*/

/*
 * Error return codes from gethostbyname() and gethostbyaddr()
 * (left in extern int h_errno).
 */

extern int h_errno;
# 159 "../../../../../include/netdb.h"
extern void endhostent (void);
extern void endnetent (void);
extern void endprotoent (void);
extern void endservent (void);
/*extern void      endrpcent  (void);*/
extern int getaddrinfo(const char *restrict host, const char *restrict serv,
    const struct addrinfo *restrict hint, struct addrinfo **restrict res);
extern void freeaddrinfo(struct addrinfo *res);
extern struct hostent *gethostbyaddr (const char *, int, int);
extern struct hostent *gethostbyname (const char *);
extern struct hostent *gethostent (void);
extern struct netent *getnetbyaddr (u_long, int); /* u_long? */
extern struct netent *getnetbyname (const char *);
extern struct netent *getnetent (void);
extern struct protoent *getprotobyname (const char *);
extern struct protoent *getprotobynumber (int);
extern struct protoent *getprotoent (void);
extern struct servent *getservbyname (const char *, const char *);
extern struct servent *getservbyport (int, const char *);
extern struct servent *getservent (void);
/*struct rpcent extern *getrpcent (void);
extern struct rpcent   *getrpcbyname (const char *);
extern struct rpcent   *getrpcbynumber (int);*/
extern void herror (char *);
extern void sethostent (int);
extern void setnetent (int);
extern void setprotoent (int);
extern void setservent (int);
/*extern void      setrpcent (int);*/
# 20 "gnetbyad.c" 2

extern int _net_stayopen;

struct netent *
getnetbyaddr(unsigned net, int type)
{
 register struct netent *p;

 setnetent(_net_stayopen);
 while ((p = getnetent()))
  if (p->n_addrtype == type && p->n_net == net)
   break;
 if (!_net_stayopen)
  endnetent();
 return (p);
}
